import greenfoot.*;
import java.util.ArrayList;
/**
 * Write a description of class DrawingWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class DrawingWorld extends World
{

    /**
     * Constructor for objects of class DrawingWorld.
     * 
     */
    public DrawingWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 

        //temp test : 
        Greenfoot.start();

    }

    public void act() {
        Greenfoot.stop(); //don't do this twice
        //get input
        String input = Greenfoot.ask("enter algorithm");  
        //complile to move array
        input.toUpperCase();
        input = removeChr(input, '(');
        input = removeChr(input, ')');
        input = removeChr(input, ' ');
        ArrayList<String> moves = new ArrayList<String>();
        for(int i = 0; i < input.length();i++) {
            char c = input.charAt(i);
            char[] move;
            if(i < input.length()-1) {
                char c1 = input.charAt(i+1);

                if(c1 == '\'' || c1 == 'i' || c1 == 'I') {
                    move = new char[] {c,'\''};
                    i++; //skip the next char because it was paired with this one 
                }else move = new char[] {c};

                if(c1 == '2') {
                    i++;
                    moves.add(new String(move)); //add the move twice
                }
            }else move = new char[] {c};           
            moves.add(new String(move));
        }
        /* old!!!
        
        //calc size
        int width = 0;
        int height = 0;
        for(String move : moves) {
            GreenfootImage moveIm = new GreenfootImage(move+".png");
            width+=moveIm.getWidth();
            if(moveIm.getHeight() > height) height = moveIm.getHeight();
        }

        //make image
        GreenfootImage image = new GreenfootImage(width,height);
        image.setColor(java.awt.Color.WHITE);
        image.fill();
        int x = 0;
        for(String move : moves) {
            GreenfootImage moveIm = new GreenfootImage(move+".png");
            image.drawImage(moveIm, x, 0);
            x+=moveIm.getWidth();
        }*/

        //scale image
        //if(image.getWidth() > maxX*4) {
            //redraw on 2 lines

            //calc size
            int width = 0;
            int height = 0;
            int secondHeight = -1;
            int secondWidth= 0;
            for(String move : moves) {
                GreenfootImage moveIm = new GreenfootImage(move+".png");
                if(secondHeight == -1) {
                    //first line

                    width+=moveIm.getWidth();
                    if(width > maxX*2) {
                        //transition
                        width-=moveIm.getWidth();
                        secondWidth+=moveIm.getWidth();
                        if(moveIm.getHeight() > secondHeight) secondHeight = moveIm.getHeight();
                    }else if(moveIm.getHeight() > height) height = moveIm.getHeight(); //first line
                }else {
                    //2nd line
                    secondWidth+=moveIm.getWidth();
                    if(moveIm.getHeight() > secondHeight) secondHeight = moveIm.getHeight();
                }
            }

            height+=secondHeight;
            if(secondWidth > width) width = secondWidth;

            //make image
            GreenfootImage image = new GreenfootImage(width,height);
            image.setColor(java.awt.Color.WHITE);
            image.fill();
            int x = 0;
            int y = 0;
            for(String move : moves) {
                GreenfootImage moveIm = new GreenfootImage(move+".png");
                x+=moveIm.getWidth();
                if(x > image.getWidth()) {
                    x = moveIm.getWidth();
                    y = height-secondHeight;
                }
                image.drawImage(moveIm, x-moveIm.getWidth(), y);
            }
        //}
        double scalingFactor = maxX/image.getWidth(); 
        image.scale((int) maxX,(int) (image.getHeight()*scalingFactor));
        Greenfoot.setWorld(new DrawingWorld(image));
    }

    public static String removeChr(String str, char x){
        StringBuilder strBuilder = new StringBuilder();
        char[] rmString = str.toCharArray();
        for(int i=0; i<rmString.length; i++){
            if(rmString[i] == x){

            } else {
                strBuilder.append(rmString[i]);
            }
        }
        return strBuilder.toString();
    }

    static final double maxX = 800;

    public DrawingWorld(GreenfootImage i) {
        super(i.getWidth(),i.getHeight(),1);
        setBackground(i);
        Greenfoot.stop();
    }
}
